=begin
#validateapi

#The validation APIs help you validate data. Check if an E-mail address is real. Check if a domain is real. Check up on an IP address, and even where it is located. All this and much more is available in the validation API.

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'uri'

module CloudmersiveValidateApiClient
  class LeadEnrichmentApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Enrich an input lead with additional fields of data
    # @param request Input lead with known fields set, and unknown fields left blank (null)
    # @param [Hash] opts the optional parameters
    # @return [LeadEnrichmentResponse]
    def lead_enrichment_enrich_lead(request, opts = {})
      data, _status_code, _headers = lead_enrichment_enrich_lead_with_http_info(request, opts)
      data
    end

    # Enrich an input lead with additional fields of data
    # @param request Input lead with known fields set, and unknown fields left blank (null)
    # @param [Hash] opts the optional parameters
    # @return [Array<(LeadEnrichmentResponse, Fixnum, Hash)>] LeadEnrichmentResponse data, response status code and response headers
    def lead_enrichment_enrich_lead_with_http_info(request, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: LeadEnrichmentApi.lead_enrichment_enrich_lead ...'
      end
      # verify the required parameter 'request' is set
      if @api_client.config.client_side_validation && request.nil?
        fail ArgumentError, "Missing the required parameter 'request' when calling LeadEnrichmentApi.lead_enrichment_enrich_lead"
      end
      # resource path
      local_var_path = '/validate/lead-enrichment/lead/enrich'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json', 'text/json', 'application/xml', 'text/xml'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'text/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(request)
      auth_names = ['Apikey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'LeadEnrichmentResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: LeadEnrichmentApi#lead_enrichment_enrich_lead\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
